
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by Francois Fleuret, (C) IDIAP                                //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

#ifndef LABELLED_IMAGE_POOL_FILE_H
#define LABELLED_IMAGE_POOL_FILE_H

#include "labelled_image_pool.h"
#include "labelled_image.h"

#include <fstream>

class LabelledImagePoolFile : public LabelledImagePool {
  int _nb_images;
  LabelledImage **_images;
  streampos *_image_stream_positions;
  int *_image_nb_refs;
  ifstream *_stream;

public:
  LabelledImagePoolFile(char *file_name);
  virtual ~LabelledImagePoolFile();

  virtual int nb_images();

  // grab_image(n) does _NOT_ build the rich structure. One has to call
  // compute_rich_structure() for that!
  virtual LabelledImage *grab_image(int n_image);
  virtual void release_image(int n_image);
};

#endif
