
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by Francois Fleuret, (C) IDIAP                                //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

#ifndef LABELLED_IMAGE_POOL_SUBSET_H
#define LABELLED_IMAGE_POOL_SUBSET_H

#include "labelled_image_pool.h"

class LabelledImagePoolSubset : public LabelledImagePool {
  LabelledImagePool *_mother_pool;
  int _nb_images;
  int *_indexes;
public:
  LabelledImagePoolSubset(LabelledImagePool *mother_pool, bool *used);
  virtual ~LabelledImagePoolSubset();
  virtual int nb_images();
  virtual LabelledImage *grab_image(int n_image);
  virtual void release_image(int n_image);
};

#endif
